SystemOrganization addCategory: #GhostProxies!

!CompiledMethod methodsFor: '*GhostProxies' stamp: 'MarianoMartinezPeck 4/20/2011 15:57'!
executeWithReceiver: aReceiver arguments: anArray 
 "Execute compiledMethod against the receiver and args in argArray. The receiver is the CompiledMethod"

<primitive: 190>
   self primitiveFailed! !

Object subclass: #ClassProxy
	instanceVariableNames: 'target handler superclass methodDict format'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ClassProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 11:52'!
createProxyAndReplace: aClass
   | aProxy newProxyRef newClassRef|
       aProxy := self new
		initializeWith: SimpleForwarderHandler new
       	methodDict: nil
       	superclass: ClassProxy
       	format: ClassProxy format.
       aProxy become: aClass.
        "After the become is done, aProxy now points to aClass 
        and aClass points to aProxy. We create two new variables
         just to clarify the code"
       newProxyRef := aClass.
       newClassRef := aProxy.
       newProxyRef target: newClassRef.
       ClassProxyTrap adoptInstance: newProxyRef.
       ^ newProxyRef.
! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 16:31'!
cannotInterpret: aMessage
	Transcript show: 'cannotInterpret message: ', aMessage selector.
	(ClassProxyTrap = aMessage lookupClass )
		ifTrue: [^ handler handleInterception: aMessage for: target proxy: self]
		ifFalse: [ ^ handler handleInterceptionToInstance: aMessage for: target andReceiver: self
]       ! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 11:53'!
initializeWith: aHandler methodDict: aMethodDict superclass: aClass format: aFormat
	super initialize.
	handler := aHandler.
	methodDict := aMethodDict.
	superclass := aClass.
	format := aFormat.! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:53'!
target: anObject
	target := anObject! !

ClassProxy subclass: #ClassProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ClassProxyTrap classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 13:30'!
initialize
	superclass := ClassProxy.
	format := ClassProxy format.
	methodDict := nil.! !

Object subclass: #Interception
	instanceVariableNames: 'message receiver target proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!Interception classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:53'!
for: aMessage target: aTargetObject proxy: aProxy receiver: aReceiver
	^ self new initializewith: aMessage 
		target: aTargetObject
		proxy: aProxy 
		receiver: aReceiver ! !

!Interception methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:39'!
initializewith: aMessage target: aTargetObject proxy: aProxy  receiver: aReceiver 
	message := aMessage.
	target := aTargetObject.
	proxy := aProxy.
	receiver := aReceiver.! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message
	^ message! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message: anObject
	message := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy
	^ proxy! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy: anObject
	proxy := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver
	^ receiver! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver: anObject
	receiver := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target
	^ target! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target: anObject
	target := anObject! !

Object subclass: #ObjectProxy
	instanceVariableNames: 'target handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 11:55'!
proxyFor: anObject
	 | aProxy |
       aProxy := self new
		initializeWith: anObject
		handler: SimpleForwarderHandler new. 
	 ObjectProxyTrap initialize.
       ObjectProxyTrap adoptInstance: aProxy.
       ^ aProxy.! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 13:46'!
cannotInterpret: aMessage
       ^ handler handleInterception: aMessage for: target proxy: self! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 11:56'!
initializeWith: anObject handler: aHandler
	target := anObject.
	handler := aHandler  
	! !

ObjectProxy subclass: #ObjectProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!ObjectProxyTrap classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 10:58'!
initialize
	superclass := ObjectProxy.
	format := ObjectProxy format.
	methodDict := nil.! !

Object subclass: #SimpleForwarderHandler
	instanceVariableNames: 'methodsNotToIntercept'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 14:01'!
defaultMethodsNotToIntercept
	| dict |
	dict := Dictionary new.
	dict at: #flushCache: put: #flushCacheOf:.
	dict at: #run:with:in: put: #handleMethodExecution:.
	dict at: #uninstall put: #uninstall:.
	^ dict
	
	! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:45'!
flushCache: anInterception
	^ anInterception target selector flushCache	 
		! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:44'!
handleInterception: aMessage for: aTargetObject proxy: proxy
	| interception |	
	Transcript show: 'message ', aMessage selector, ' intercepted and will be forwarded'; cr.
	interception := Interception for: aMessage target: aTargetObject proxy: proxy receiver: nil. 
	(self isMessageNotToIntercept: aMessage)
		ifTrue: [ ^ self manageMessageInternally: interception ]
	 	ifFalse: [ ^ self manageMessage: interception  ]! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 15:59'!
handleInterceptionToInstance: aMessage for: aClass andReceiver: anInstance

	Transcript show: 'message ', aMessage selector, ' to instance intercepted and will be forwarded'; cr.
	^ (aClass lookupSelector: aMessage selector) 
		executeWithReceiver: anInstance arguments: aMessage arguments 
	! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:46'!
handleMethodExecution: anInterception
	Transcript show: 'message ', anInterception message selector, ' execution intercepted and will be forwarded'; cr.
	^ anInterception target valueWithReceiver: anInterception message arguments third arguments: anInterception message arguments second
	
! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:48'!
isMessageNotToIntercept: aMessage
	^ self methodsNotToIntercept includesKey: aMessage selector  ! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:49'!
manageMessage: interception
	^ interception message sendTo: interception target! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:55'!
manageMessageInternally: anInterception 
	^ self perform: (self methodsNotToIntercept at: anInterception message selector) with: anInterception ! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:29'!
methodsNotToIntercept
	methodsNotToIntercept isNil ifTrue: [ methodsNotToIntercept := self defaultMethodsNotToIntercept ].
	^ methodsNotToIntercept ! !

!SimpleForwarderHandler methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:47'!
uninstall: anInterception

	Transcript show: 'message ', anInterception message selector, ' received and the proxy will be uninstalled'; cr.
	^ anInterception target become: anInterception proxy.
	! !
ClassProxyTrap initialize!
ObjectProxyTrap initialize!
